Index: kernel/generic/src/ipc/ipc.c
===================================================================
--- kernel/generic/src/ipc/ipc.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/src/ipc/ipc.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,8 +38,10 @@
  */
 
+#include <assert.h>
 #include <synch/spinlock.h>
 #include <synch/mutex.h>
 #include <synch/waitq.h>
 #include <ipc/ipc.h>
+#include <ipc/ipcrsc.h>
 #include <abi/ipc/methods.h>
 #include <ipc/kbox.h>
@@ -51,6 +53,5 @@
 #include <arch.h>
 #include <proc/task.h>
-#include <memstr.h>
-#include <debug.h>
+#include <mem.h>
 #include <print.h>
 #include <console/console.h>
@@ -58,4 +59,5 @@
 #include <arch/interrupt.h>
 #include <ipc/irq.h>
+#include <cap/cap.h>
 
 static void ipc_forget_call(call_t *);
@@ -64,6 +66,8 @@
 answerbox_t *ipc_phone_0 = NULL;
 
-static slab_cache_t *ipc_call_slab;
-static slab_cache_t *ipc_answerbox_slab;
+static slab_cache_t *call_slab;
+static slab_cache_t *answerbox_slab;
+
+slab_cache_t *phone_slab = NULL; 
 
 /** Initialize a call structure.
@@ -93,5 +97,5 @@
 		if (call->buffer)
 			free(call->buffer);
-		slab_free(ipc_call_slab, call);
+		slab_free(call_slab, call);
 	}
 }
@@ -110,5 +114,5 @@
 call_t *ipc_call_alloc(unsigned int flags)
 {
-	call_t *call = slab_alloc(ipc_call_slab, flags);
+	call_t *call = slab_alloc(call_slab, flags);
 	if (call) {
 		_ipc_call_init(call);
@@ -145,5 +149,4 @@
 	list_initialize(&box->answers);
 	list_initialize(&box->irq_notifs);
-	list_initialize(&box->irq_list);
 	box->task = task;
 }
@@ -151,7 +154,9 @@
 /** Connect a phone to an answerbox.
  *
- * @param phone Initialized phone structure.
- * @param box   Initialized answerbox structure.
- * @return      True if the phone was connected, false otherwise.
+ * This function must be passed a reference to phone->kobject.
+ *
+ * @param phone  Initialized phone structure.
+ * @param box    Initialized answerbox structure.
+ * @return       True if the phone was connected, false otherwise.
  */
 bool ipc_phone_connect(phone_t *phone, answerbox_t *box)
@@ -166,4 +171,5 @@
 		phone->state = IPC_PHONE_CONNECTED;
 		phone->callee = box;
+		/* Pass phone->kobject reference to box->connected_phones */
 		list_append(&phone->link, &box->connected_phones);
 	}
@@ -171,4 +177,9 @@
 	irq_spinlock_unlock(&box->lock, true);
 	mutex_unlock(&phone->lock);
+
+	if (!active) {
+		/* We still have phone->kobject's reference; drop it */
+		kobject_put(phone->kobject);
+	}
 
 	return active;
@@ -188,4 +199,5 @@
 	phone->state = IPC_PHONE_FREE;
 	atomic_set(&phone->active_calls, 0);
+	phone->kobject = NULL;
 }
 
@@ -200,5 +212,5 @@
 int ipc_call_sync(phone_t *phone, call_t *request)
 {
-	answerbox_t *mybox = slab_alloc(ipc_answerbox_slab, 0);
+	answerbox_t *mybox = slab_alloc(answerbox_slab, 0);
 	ipc_answerbox_init(mybox, TASK);
 	
@@ -208,5 +220,5 @@
 	int rc = ipc_call(phone, request);
 	if (rc != EOK) {
-		slab_free(ipc_answerbox_slab, mybox);
+		slab_free(answerbox_slab, mybox);
 		return rc;
 	}
@@ -227,5 +239,5 @@
 		spinlock_lock(&TASK->active_calls_lock);
 
-		ASSERT(!request->forget);
+		assert(!request->forget);
 
 		bool answered = !request->active;
@@ -253,7 +265,7 @@
 		}
 	}
-	ASSERT(!answer || request == answer);
-	
-	slab_free(ipc_answerbox_slab, mybox);
+	assert(!answer || request == answer);
+	
+	slab_free(answerbox_slab, mybox);
 	return rc;
 }
@@ -453,4 +465,7 @@
 		list_remove(&phone->link);
 		irq_spinlock_unlock(&box->lock, true);
+
+		/* Drop the answerbox reference */
+		kobject_put(phone->kobject);
 		
 		call_t *call = ipc_call_alloc(0);
@@ -631,5 +646,5 @@
 		
 		/* Disconnect phone */
-		ASSERT(phone->state == IPC_PHONE_CONNECTED);
+		assert(phone->state == IPC_PHONE_CONNECTED);
 		
 		list_remove(&phone->link);
@@ -655,4 +670,6 @@
 
 			task_release(phone->caller);
+
+			kobject_put(phone->kobject);
 			
 			/* Must start again */
@@ -661,4 +678,5 @@
 		
 		mutex_unlock(&phone->lock);
+		kobject_put(phone->kobject);
 	}
 	
@@ -668,6 +686,6 @@
 static void ipc_forget_call(call_t *call)
 {
-	ASSERT(spinlock_locked(&TASK->active_calls_lock));
-	ASSERT(spinlock_locked(&call->forget_lock));
+	assert(spinlock_locked(&TASK->active_calls_lock));
+	assert(spinlock_locked(&call->forget_lock));
 
 	/*
@@ -707,5 +725,5 @@
 		 * Nota bene: there may still be answers waiting for pick up.
 		 */
-		spinlock_unlock(&TASK->active_calls_lock);	
+		spinlock_unlock(&TASK->active_calls_lock);
 		return;	
 	}
@@ -720,5 +738,5 @@
 		 * call on the list.
 		 */
-		spinlock_unlock(&TASK->active_calls_lock);	
+		spinlock_unlock(&TASK->active_calls_lock);
 		goto restart;
 	}
@@ -727,4 +745,50 @@
 
 	goto restart;
+}
+
+static bool phone_cap_wait_cb(cap_t *cap, void *arg)
+{
+	phone_t *phone = cap->kobject->phone;
+	bool *restart = (bool *) arg;
+
+	mutex_lock(&phone->lock);
+	if ((phone->state == IPC_PHONE_HUNGUP) &&
+	    (atomic_get(&phone->active_calls) == 0)) {
+		phone->state = IPC_PHONE_FREE;
+		phone->callee = NULL;
+	}
+
+	/*
+	 * We might have had some IPC_PHONE_CONNECTING phones at the beginning
+	 * of ipc_cleanup(). Depending on whether these were forgotten or
+	 * answered, they will eventually enter the IPC_PHONE_FREE or
+	 * IPC_PHONE_CONNECTED states, respectively.  In the latter case, the
+	 * other side may slam the open phones at any time, in which case we
+	 * will get an IPC_PHONE_SLAMMED phone.
+	 */
+	if ((phone->state == IPC_PHONE_CONNECTED) ||
+	    (phone->state == IPC_PHONE_SLAMMED)) {
+		mutex_unlock(&phone->lock);
+		ipc_phone_hangup(phone);
+		/*
+		 * Now there may be one extra active call, which needs to be
+		 * forgotten.
+		 */
+		ipc_forget_all_active_calls();
+		*restart = true;
+		return false;
+	}
+
+	/*
+	 * If the hangup succeeded, it has sent a HANGUP message, the IPC is now
+	 * in HUNGUP state, we wait for the reply to come
+	 */
+	if (phone->state != IPC_PHONE_FREE) {
+		mutex_unlock(&phone->lock);
+		return false;
+	}
+
+	mutex_unlock(&phone->lock);
+	return true;
 }
 
@@ -733,5 +797,5 @@
 {
 	call_t *call;
-	size_t i;
+	bool restart;
 
 restart:
@@ -740,54 +804,16 @@
 	 * Locking is needed as there may be connection handshakes in progress.
 	 */
-	for (i = 0; i < IPC_MAX_PHONES; i++) {
-		phone_t *phone = &TASK->phones[i];
-
-		mutex_lock(&phone->lock);	
-		if ((phone->state == IPC_PHONE_HUNGUP) &&
-		    (atomic_get(&phone->active_calls) == 0)) {
-			phone->state = IPC_PHONE_FREE;
-			phone->callee = NULL;
-		}
-
-		/*
-		 * We might have had some IPC_PHONE_CONNECTING phones at the
-		 * beginning of ipc_cleanup(). Depending on whether these were
-		 * forgotten or answered, they will eventually enter the
-		 * IPC_PHONE_FREE or IPC_PHONE_CONNECTED states, respectively.
-		 * In the latter case, the other side may slam the open phones
-		 * at any time, in which case we will get an IPC_PHONE_SLAMMED
-		 * phone.
-		 */
-		if ((phone->state == IPC_PHONE_CONNECTED) ||
-		    (phone->state == IPC_PHONE_SLAMMED)) {
-			mutex_unlock(&phone->lock);
-			ipc_phone_hangup(phone);
-			/*
-			 * Now there may be one extra active call, which needs
-			 * to be forgotten.
-			 */
-			ipc_forget_all_active_calls();
-			goto restart;
-		}
-
-		/*
-		 * If the hangup succeeded, it has sent a HANGUP message, the
-		 * IPC is now in HUNGUP state, we wait for the reply to come
-		 */
-		if (phone->state != IPC_PHONE_FREE) {
-			mutex_unlock(&phone->lock);
-			break;
-		}
-
-		mutex_unlock(&phone->lock);
-	}
-		
-	/* Got into cleanup */
-	if (i == IPC_MAX_PHONES)
+	restart = false;
+	if (caps_apply_to_kobject_type(TASK, KOBJECT_TYPE_PHONE,
+	    phone_cap_wait_cb, &restart)) {
+		/* Got into cleanup */
 		return;
-		
+	}
+	if (restart)
+		goto restart;
+	
 	call = ipc_wait_for_call(&TASK->answerbox, SYNCH_NO_TIMEOUT,
 	    SYNCH_FLAGS_NONE);
-	ASSERT(call->flags & (IPC_CALL_ANSWERED | IPC_CALL_NOTIF));
+	assert(call->flags & (IPC_CALL_ANSWERED | IPC_CALL_NOTIF));
 
 	SYSIPC_OP(answer_process, call);
@@ -795,4 +821,16 @@
 	ipc_call_free(call);
 	goto restart;
+}
+
+static bool phone_cap_cleanup_cb(cap_t *cap, void *arg)
+{
+	ipc_phone_hangup(cap->kobject->phone);
+	return true;
+}
+
+static bool irq_cap_cleanup_cb(cap_t *cap, void *arg)
+{
+	ipc_irq_unsubscribe(&TASK->answerbox, cap->handle);
+	return true;
 }
 
@@ -816,12 +854,13 @@
 
 	/* Disconnect all our phones ('ipc_phone_hangup') */
-	for (size_t i = 0; i < IPC_MAX_PHONES; i++)
-		ipc_phone_hangup(&TASK->phones[i]);
+	caps_apply_to_kobject_type(TASK, KOBJECT_TYPE_PHONE,
+	    phone_cap_cleanup_cb, NULL);
 	
 	/* Unsubscribe from any event notifications. */
 	event_cleanup_answerbox(&TASK->answerbox);
 	
-	/* Disconnect all connected irqs */
-	ipc_irq_cleanup(&TASK->answerbox);
+	/* Disconnect all connected IRQs */
+	caps_apply_to_kobject_type(TASK, KOBJECT_TYPE_IRQ, irq_cap_cleanup_cb,
+	    NULL);
 	
 	/* Disconnect all phones connected to our regular answerbox */
@@ -847,8 +886,10 @@
 void ipc_init(void)
 {
-	ipc_call_slab = slab_cache_create("call_t", sizeof(call_t), 0, NULL,
+	call_slab = slab_cache_create("call_t", sizeof(call_t), 0, NULL,
 	    NULL, 0);
-	ipc_answerbox_slab = slab_cache_create("answerbox_t",
-	    sizeof(answerbox_t), 0, NULL, NULL, 0);
+	phone_slab = slab_cache_create("phone_t", sizeof(phone_t), 0, NULL,
+	    NULL, 0);
+	answerbox_slab = slab_cache_create("answerbox_t", sizeof(answerbox_t),
+	    0, NULL, NULL, 0);
 }
 
@@ -885,4 +926,39 @@
 }
 
+static bool print_task_phone_cb(cap_t *cap, void *arg)
+{
+	phone_t *phone = cap->kobject->phone;
+
+	mutex_lock(&phone->lock);
+	if (phone->state != IPC_PHONE_FREE) {
+		printf("%-11d %7" PRIun " ", cap->handle,
+		    atomic_get(&phone->active_calls));
+		
+		switch (phone->state) {
+		case IPC_PHONE_CONNECTING:
+			printf("connecting");
+			break;
+		case IPC_PHONE_CONNECTED:
+			printf("connected to %" PRIu64 " (%s)",
+			    phone->callee->task->taskid,
+			    phone->callee->task->name);
+			break;
+		case IPC_PHONE_SLAMMED:
+			printf("slammed by %p", phone->callee);
+			break;
+		case IPC_PHONE_HUNGUP:
+			printf("hung up by %p", phone->callee);
+			break;
+		default:
+			break;
+		}
+		
+		printf("\n");
+	}
+	mutex_unlock(&phone->lock);
+
+	return true;
+}
+
 /** List answerbox contents.
  *
@@ -894,53 +970,17 @@
 	irq_spinlock_lock(&tasks_lock, true);
 	task_t *task = task_find_by_id(taskid);
-	
 	if (!task) {
 		irq_spinlock_unlock(&tasks_lock, true);
 		return;
 	}
-	
-	/* Hand-over-hand locking */
-	irq_spinlock_exchange(&tasks_lock, &task->lock);
-	
-	printf("[phone id] [calls] [state\n");
-	
-	size_t i;
-	for (i = 0; i < IPC_MAX_PHONES; i++) {
-		if (SYNCH_FAILED(mutex_trylock(&task->phones[i].lock))) {
-			printf("%-10zu (mutex busy)\n", i);
-			continue;
-		}
-		
-		if (task->phones[i].state != IPC_PHONE_FREE) {
-			printf("%-10zu %7" PRIun " ", i,
-			    atomic_get(&task->phones[i].active_calls));
-			
-			switch (task->phones[i].state) {
-			case IPC_PHONE_CONNECTING:
-				printf("connecting");
-				break;
-			case IPC_PHONE_CONNECTED:
-				printf("connected to %" PRIu64 " (%s)",
-				    task->phones[i].callee->task->taskid,
-				    task->phones[i].callee->task->name);
-				break;
-			case IPC_PHONE_SLAMMED:
-				printf("slammed by %p",
-				    task->phones[i].callee);
-				break;
-			case IPC_PHONE_HUNGUP:
-				printf("hung up by %p",
-				    task->phones[i].callee);
-				break;
-			default:
-				break;
-			}
-			
-			printf("\n");
-		}
-		
-		mutex_unlock(&task->phones[i].lock);
-	}
-	
+	task_hold(task);
+	irq_spinlock_unlock(&tasks_lock, true);
+	
+	printf("[phone cap] [calls] [state\n");
+	
+	caps_apply_to_kobject_type(task, KOBJECT_TYPE_PHONE,
+	    print_task_phone_cb, NULL);
+	
+	irq_spinlock_lock(&task->lock, true);
 	irq_spinlock_lock(&task->answerbox.lock, false);
 	
@@ -964,4 +1004,6 @@
 	irq_spinlock_unlock(&task->answerbox.lock, false);
 	irq_spinlock_unlock(&task->lock, true);
+
+	task_release(task);
 }
 
Index: kernel/generic/src/ipc/ipcrsc.c
===================================================================
--- kernel/generic/src/ipc/ipcrsc.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/src/ipc/ipcrsc.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,5 +39,5 @@
  *
  * The pattern of usage of the resources is:
- * - allocate empty phone slot, connect | deallocate slot
+ * - allocate empty phone capability slot, connect | deallocate slot
  * - disconnect connected phone (some messages might be on the fly)
  * - find phone in slot and send a message using phone
@@ -53,5 +53,5 @@
  *   atomic on all platforms)
  *
- * - To find an empty phone slot, the TASK must be locked
+ * - To find an empty phone capability slot, the TASK must be locked
  * - To answer a message, the answerbox must be locked
  * - The locking of phone and answerbox is done at the ipc_ level.
@@ -77,10 +77,10 @@
  *
  * *** Connect_to_me ***
- * The caller sends IPC_M_CONNECT_TO_ME. 
+ * The caller sends IPC_M_CONNECT_TO_ME.
  * The server receives an automatically opened phoneid. If it accepts
- * (RETVAL=0), it can use the phoneid immediately. 
- * Possible race condition can arise, when the client receives messages from new
- * connection before getting response for connect_to_me message. Userspace
- * should implement handshake protocol that would control it.
+ * (RETVAL=0), it can use the phoneid immediately.  Possible race condition can
+ * arise, when the client receives messages from new connection before getting
+ * response for connect_to_me message. Userspace should implement handshake
+ * protocol that would control it.
  *
  * Phone hangup
@@ -89,18 +89,19 @@
  * - The phone is disconnected (no more messages can be sent over this phone),
  *   all in-progress messages are correctly handled. The answerbox receives
- *   IPC_M_PHONE_HUNGUP call from the phone that hung up. When all async
- *   calls are answered, the phone is deallocated.
+ *   IPC_M_PHONE_HUNGUP call from the phone that hung up. When all async calls
+ *   are answered, the phone is deallocated.
  *
  * *** The answerbox hangs up (ipc_answer(EHANGUP))
- * - The phone is disconnected. EHANGUP response code is sent
- *   to the calling task. All new calls through this phone
- *   get a EHUNGUP error code, the task is expected to
- *   send an sys_ipc_hangup after cleaning up its internal structures.
+ * - The phone is disconnected. EHANGUP response code is sent to the calling
+ *   task. All new calls through this phone get a EHUNGUP error code, the task
+ *   is expected to send an sys_ipc_hangup after cleaning up its internal
+ *   structures.
+ *
  *
  * Call forwarding
  *
- * The call can be forwarded, so that the answer to call is passed directly
- * to the original sender. However, this poses special problems regarding 
- * routing of hangup messages.
+ * The call can be forwarded, so that the answer to call is passed directly to
+ * the original sender. However, this poses special problems regarding routing
+ * of hangup messages.
  *
  * sys_ipc_hangup -> IPC_M_PHONE_HUNGUP
@@ -131,6 +132,8 @@
 #include <proc/task.h>
 #include <ipc/ipcrsc.h>
-#include <debug.h>
+#include <assert.h>
 #include <abi/errno.h>
+#include <cap/cap.h>
+#include <mm/slab.h>
 
 /** Find call_t * in call table according to callid.
@@ -138,9 +141,8 @@
  * @todo Some speedup (hash table?)
  *
- * @param callid Userspace hash of the call. Currently it is the call
- *               structure kernel address.
- *
- * @return NULL on not found, otherwise pointer to the call
- *         structure.
+ * @param callid Userspace hash of the call. Currently it is the call structure
+ *               kernel address.
+ *
+ * @return NULL on not found, otherwise pointer to the call structure.
  *
  */
@@ -162,66 +164,63 @@
 }
 
-/** Get phone from the current task by ID.
- *
- * @param phoneid Phone ID.
- * @param phone   Place to store pointer to phone.
- *
- * @return EOK on success, EINVAL if ID is invalid.
- *
- */
-int phone_get(sysarg_t phoneid, phone_t **phone)
-{
-	if (phoneid >= IPC_MAX_PHONES)
-		return EINVAL;
-	
-	*phone = &TASK->phones[phoneid];
-	return EOK;
-}
-
-/** Allocate new phone slot in the specified task.
- *
- * @param task Task for which to allocate a new phone.
- *
- * @return New phone handle or -1 if the phone handle limit is
- *         exceeded.
- *
- */
-int phone_alloc(task_t *task)
-{
-	irq_spinlock_lock(&task->lock, true);
-	
-	size_t i;
-	for (i = 0; i < IPC_MAX_PHONES; i++) {
-		phone_t *phone = &task->phones[i];
-
-		if ((phone->state == IPC_PHONE_HUNGUP) &&
-		    (atomic_get(&phone->active_calls) == 0))
-			phone->state = IPC_PHONE_FREE;
+static bool phone_reclaim(kobject_t *kobj)
+{
+	bool gc = false;
+
+	mutex_lock(&kobj->phone->lock);
+	if (kobj->phone->state == IPC_PHONE_HUNGUP &&
+	    atomic_get(&kobj->phone->active_calls) == 0)
+		gc = true;
+	mutex_unlock(&kobj->phone->lock);
+
+	return gc;
+}
+
+static void phone_destroy(void *arg)
+{
+	phone_t *phone = (phone_t *) arg;
+	slab_free(phone_slab, phone);
+}
+
+static kobject_ops_t phone_kobject_ops = {
+	.reclaim = phone_reclaim,
+	.destroy = phone_destroy
+};
+
+
+/** Allocate new phone in the specified task.
+ *
+ * @param task  Task for which to allocate a new phone.
+ *
+ * @return  New phone capability handle.
+ * @return  Negative error code if a new capability cannot be allocated.
+ */
+cap_handle_t phone_alloc(task_t *task)
+{
+	cap_handle_t handle = cap_alloc(task);
+	if (handle >= 0) {
+		phone_t *phone = slab_alloc(phone_slab, FRAME_ATOMIC);
+		if (!phone) {
+			cap_free(TASK, handle);
+			return ENOMEM;
+		}
+		kobject_t *kobject = malloc(sizeof(kobject_t), FRAME_ATOMIC);
+		if (!kobject) {
+			cap_free(TASK, handle);
+			slab_free(phone_slab, phone);
+			return ENOMEM;
+		}
+
+		ipc_phone_init(phone, task);
+		phone->state = IPC_PHONE_CONNECTING;
+
+		kobject_initialize(kobject, KOBJECT_TYPE_PHONE, phone,
+		    &phone_kobject_ops);
+		phone->kobject = kobject;
 		
-		if (phone->state == IPC_PHONE_FREE) {
-			phone->state = IPC_PHONE_CONNECTING;
-			break;
-		}
+		cap_publish(task, handle, kobject);
 	}
 	
-	irq_spinlock_unlock(&task->lock, true);
-	
-	if (i == IPC_MAX_PHONES)
-		return -1;
-	
-	return i;
-}
-
-/** Mark a phone structure free.
- *
- * @param phone Phone structure to be marked free.
- *
- */
-static void phone_deallocp(phone_t *phone)
-{
-	ASSERT(phone->state == IPC_PHONE_CONNECTING);
-	
-	/* Atomic operation */
-	phone->state = IPC_PHONE_FREE;
+	return handle;
 }
 
@@ -230,29 +229,36 @@
  * All already sent messages will be correctly processed.
  *
- * @param phoneid Phone handle of the phone to be freed.
- *
- */
-void phone_dealloc(int phoneid)
-{
-	phone_deallocp(&TASK->phones[phoneid]);
+ * @param handle Phone capability handle of the phone to be freed.
+ *
+ */
+void phone_dealloc(cap_handle_t handle)
+{
+	kobject_t *kobj = cap_unpublish(TASK, handle, KOBJECT_TYPE_PHONE);
+	if (!kobj)
+		return;
+	
+	assert(kobj->phone);
+	assert(kobj->phone->state == IPC_PHONE_CONNECTING);
+	
+	kobject_put(kobj);
+	cap_free(TASK, handle);
 }
 
 /** Connect phone to a given answerbox.
  *
- * @param phoneid Phone handle to be connected.
- * @param box     Answerbox to which to connect the phone handle.
+ * @param handle  Capability handle of the phone to be connected.
+ * @param box     Answerbox to which to connect the phone.
  * @return        True if the phone was connected, false otherwise.
- *
- * The procedure _enforces_ that the user first marks the phone
- * busy (e.g. via phone_alloc) and then connects the phone, otherwise
- * race condition may appear.
- *
- */
-bool phone_connect(int phoneid, answerbox_t *box)
-{
-	phone_t *phone = &TASK->phones[phoneid];
-	
-	ASSERT(phone->state == IPC_PHONE_CONNECTING);
-	return ipc_phone_connect(phone, box);
+ */
+bool phone_connect(cap_handle_t handle, answerbox_t *box)
+{
+	kobject_t *phone_obj = kobject_get(TASK, handle, KOBJECT_TYPE_PHONE);
+	if (!phone_obj)
+		return false;
+	
+	assert(phone_obj->phone->state == IPC_PHONE_CONNECTING);
+	
+	/* Hand over phone_obj reference to the answerbox */
+	return ipc_phone_connect(phone_obj->phone, box);
 }
 
